<?php if(!defined("IN_MYBB")) die("Access Denied");


// Make sure this function hasn't already been hooked.
if (!isset($plugins->hooks[admin_config_settings_change][10][beardy_admin_config_settings_change])) {
    $plugins->add_hook("admin_config_settings_change", "beardy_admin_config_settings_change");
}

// Don't bless this mess.
// This is used to parse input for the admin settings. 
// It checks for an array and implodes it into a comma-seperated string so
// multi-select box input can be stored into the database (see 'form_groupselect_box' in this file).
// If there's a more eloquent and built-in way to do this, feel free to try and tell me.
if (!function_exists("beardy_admin_config_settings_change")) {
    function beardy_admin_config_settings_change() {
        global $mybb;

        if($mybb->request_method == "post") {
            foreach ($mybb->input['upsetting'] as $setting => $values) {
                if (is_array($values)) {
                    $mybb->input['upsetting'][$setting] = implode(",", $values);
                }
            }
        } // Rise of the curly brackets. Coming to a github repository near you.
    }
}

if (!function_exists("acp_settings_add")) {
    function acp_settings_add($settings_group, $settings, $safe_add = FALSE) {
        global $db;

        if($safe_add == TRUE) {
                acp_remove_settinggroup($settings_group['name']);
        }

        // if the disporder field was ommited, calculate the disporder for each setting on-the-fly
        if (!isset($settings_group['disporder'])) {
                // Count the total number of setting groups
                $rows = $db->fetch_field($db->simple_select("settinggroups", "COUNT(*) as rows"), "rows");

                $settings_group['disporder'] = $rows+1;
        }

        $group['gid'] = $db->insert_query("settinggroups", $settings_group);

        foreach ($settings as $disporder => $setting) {
                $setting['gid'] = $group['gid'];
                $setting['disporder'] = isset($setting['disporder']) ? $setting['disporder'] : $disporder;

                $db->insert_query("settings", $setting);
        };	

        rebuild_settings();
    }
}

if (!function_exists("acp_settings_remove")) {
    function acp_settings_remove($settings_group_name) {
            global $db;

            // Get the settings group ID
            $settings_gid = $db->fetch_field($db->simple_select("settinggroups", "*", "name='{$settings_group_name}'"), "gid");

            // Delete the setting group
            $db->write_query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name = '{$settings_group_name}'");

            // Remove all settings
            $db->write_query("DELETE FROM ".TABLE_PREFIX."settings WHERE gid='{$settings_gid}'");

            rebuild_settings();
    }
}

if (!function_exists("get_settings_link")) {
    function get_settings_link($group_name) {
        global $db, $mybb;
        
        $gid = $db->fetch_field($db->simple_select("settinggroups", "*", "name='{$group_name}'"), "gid");
        return empty($gid) ? "" : "<a style='text-size: 10px;font-style: italic;' href='index.php?module=config-settings&action=change&gid={$gid}'>[Configure settings]</a><br />";
    }
}

if (!function_exists("plugin_is_active")) {
    function plugin_is_active($plugin="") {
        global $cache;
        
        if (!empty($plugin)) {
            $plugin_name = $plugin;
        } else {
            if (function_exists("debug_backtrace")) {
                // Do some nifty tricks to get the plugin name
                $backtrace = debug_backtrace();

                foreach ($backtrace as $step) {
                    if (array_key_exists("function", $step)) {
                        if (stristr($step['function'], "_info")) {
                            $plugin_name = str_replace("_info", "", $step['function']);
                        }
                    }
                }
            }
        }
            
        if (isset($cache->cache['plugins']['active'][$plugin_name])) {
            return true;
        } else {
            return false;
        }
        
        return "<span style='font-weight: normal; font-style: italic; color: {$color}!important;'>".htmlentities($prefix)."</span>";
    }
}

if (!function_exists("get_plugin_prefix")) {
    function get_plugin_prefix($prefix="<b> ", $color="") {
        global $cache;
        
        if (plugin_is_active()) {
            $color = "#3399FF"; // Active
        } else {
            $color = "#B20000"; // Not active
        }
        
        return "<span style='font-weight: normal; font-style: italic; color: {$color}!important;'>".htmlentities($prefix)."</span>";
    }
}

/* This is incredibly messy, but it works without the need to edit any core admin files. */
if (!function_exists("form_groupselect_box")) {
    function form_groupselect_box($name="", $selected=array(), $options=array()) {
        $name = (empty($name)) ? '$element_name' : "\'{$name}\'";
        
        $selected = (empty($selected)) ? 'explode(",", $setting["value"])' : $selected;
        $options = (empty($options)) ? "array(\\'id\\' => \$element_id, \\'multiple\\' => true, \\'size\\' => \\'12\\')" : $options;
        
        return 'php\n".$form->generate_group_select('.$name.'."[]", '.$selected.', '.$options.')."';
    }
}

if (!function_exists("pr")) {
    function pr($a,$f=true) {
        echo "<pre style='text-align: left;'>";
        print_r($a);
        echo "</pre>";
        if ($f) die();
    }
}

if (!function_exists("vd")) {
    function vd($v,$f=true) {
        echo "<pre style='text-align: left;'>";
        var_dump($vd);
        echo "</pre>";
        if ($f) die();
    }
}