<?php
/* Multiple hooks onto single functions, I've DRY humped all over this file. */
$plugins->add_hook("search_results_post", "threadpass_search_results_post");
$plugins->add_hook("search_results_thread", "threadpass_forumdisplay_thread");
$plugins->add_hook('search_do_search_process', 'threadpass_search_latest');
$plugins->add_hook("newthread_start", "threadpass_newthread_start");
$plugins->add_hook("editpost_start", "threadpass_newthread_start");
$plugins->add_hook("newthread_do_newthread_end", "threadpass_newthread_do_newthread_end");
$plugins->add_hook("editpost_do_editpost_end", "threadpass_newthread_do_newthread_end");
$plugins->add_hook("archive_thread_start", "threadpass_thread");
$plugins->add_hook("showthread_start", "threadpass_thread");
$plugins->add_hook("newreply_start", "threadpass_thread");
$plugins->add_hook("printthread_end", "threadpass_thread");
$plugins->add_hook("newreply_do_newreply_start", "threadpass_thread");
$plugins->add_hook("attachment_end", "threadpass_thread");
$plugins->add_hook("forumdisplay_thread", "threadpass_forumdisplay_thread");
$plugins->add_hook("misc_start", "threadpass_misc_start");
$plugins->add_hook("parse_message_end", "threadpass_parse_message_end");
$plugins->add_hook("showthread_start", "threadpass_showthread_start");
function threadpass_search_latest() {
	global $mybb, $thread, $searcharray;
	if ($mybb->input['action'] != 'getnew' && $mybb->input['action'] != 'getdaily' && $mybb->input['action'] != 'unreads') return;
	global $db, $where_sql;

	if (threadpass_is_super($mybb->user['uid'])) {
		$where_sql.= "";
	} else {
		$slowlogic = 1;
		$tauth = $mybb->user['threadpass_authenticated'];
		$datelimit = time() - 31556926; // минус год чтобы не нагружать базу данных давно устаревшими темами (я не знаю как получить на этом этапе список тем — $searcharray, $pids, $thread недоступны!)
		// получаем массив тем пользователя
		$query = $db->simple_select("threads", "tid", "uid={$mybb->user['uid']} AND lastpost > {$datelimit}", array("LIMIT" => 100));
		while ($userthreads_temp = $db->fetch_array($query)) {
			$userthreads[$userthreads_temp['tid']] = $userthreads_temp['tid'];
		}
	}

	if (isset($slowlogic) && empty($tauth) && empty($userthreads)) { // нет ни одной авторизованной темы, не нужно стараться
		$where_sql.= ' AND NOT threadpass_protected=1';
	} elseif (isset($slowlogic)) {
		// Получаем массив с авторизованными темами
		$tauth = unserialize($tauth);
		// Получаем массив с запароленными темами
		$query = $db->simple_select("threads", "tid", "threadpass_protected=1 AND lastpost > {$datelimit}", array("LIMIT" => 100));
		$threadspass_unread = [];
		while ($threadspass = $db->fetch_array($query)) {
			$threadspass_unread[$threadspass['tid']] = $threadspass['tid'];
			if (!is_null($tauth) && !empty($tauth) && array_key_exists($threadspass['tid'], $tauth)) {
				unset($threadspass_unread[$threadspass['tid']]); // удаляем все авторизованные темы из запаролленых
			}
			if (!is_null($userthreads) && !empty($userthreads) && array_key_exists($threadspass['tid'], $userthreads)) {
				unset($threadspass_unread[$userthreads[$threadspass['tid']]]); // удаляем все темы автора из запаролленых
			}
		}
		$threadspass_unread = implode(',', $threadspass_unread);
		if ($threadspass_unread) {
			$where_sql = ' t.tid NOT IN (' . $threadspass_unread . ')';
		}
	}
	$searcharray['querycache'] = $db->escape_string($where_sql);
}
/* Viewing search results by post */
function threadpass_search_results_post() {
	global $prev, $post, $lang;
	$lang->load("threadpass");
	if (!threadpass_allowed(get_thread($post['tid']))) {
		// This is pretty lazy. Ideally I'd want the entire result to
		// be hidden from the search results but I haven't the patience to do it.
		// NightFox: добавлен перевод и скрытие других полей. Скрыть целиком сообщение и правда сложновато.
		$prev = $lang->notpermission;
		$icon = [];
		$thread_url = "";
		$post_url = "";
		$posted = "";
		$post = [];
		$post['profilelink'] = $lang->unknown;
		/*
		$post['thread_subject'] = "*";
		$post['subject'] = "*";
		*/
		$post['forumlink'] = "*";
		$post['thread_replies'] = "*";
		$post['thread_views'] = "*";
	}
}
/* Creating a new thread OR */
/* Editing a post */
function threadpass_newthread_start() {
	global $templates, $mybb, $threadpass_row, $lang;
	$lang->load("threadpass");
	$threadpass_password_value = $threadpass_row = "";
	$post = get_post(intval($mybb->input['pid']));
	$thread = get_thread($post['tid']);
	// if we're trying to edit the first post in a thread
	if ($post['replyto'] == 0) {
		if (!empty($thread)) {
			if (threadpass_allowed($thread)) {
				// $threadpass_password_value = $thread['threadpass_password'];
				// print var_export($thread['threadpass_password']); die;
				if ($thread['threadpass_password'] == "") {
					$threadpass_password_value = "";
				}
				else {
					$threadpass_password_value = "********";
				}
			}
		}
	}
	// If this thread has no password...
	if ($thread['threadpass_protected'] == 0) {
		// if they're not in the allowed usergroups
		if (!in_array($mybb->user['usergroup'], threadpass_allowed_usergroups())) {
			// Don't show the password field.
			// I do all this so that people who aren't allowed to add passwords
			// can still edit the password on their own thread, so long as they don't
			// remove it.
			return;
		}
	}
	//	print var_export($thread); die;
	// NightFox: только для первого сообщения.
	if ($post['pid'] == $thread['firstpost']) {
		eval("\$threadpass_row = \"" . $templates->get('threadpass_row') . "\";");
	}
}
/* Processing a new thread OR */
/* Commiting an edit to a post */
function threadpass_newthread_do_newthread_end() {
	global $templates, $mybb, $tid, $db, $thread;
	// If they're attempting to set the thread password...
	if (isset($mybb->input['threadpass_password'])) {
		if (threadpass_allowed($thread)) {
			// Make sure they've actually changed the password
			if ($mybb->input['threadpass_password'] != "********") {
				// If the password was empty, set the thread as not protected.
				if (empty($mybb->input['threadpass_password'])) {
					$protected = 0;
					$threadpass_password = "";
				}
				else {
					$protected = 1;
					$threadpass_password = md5(md5("a035e42c2d0b3b57017ae736545800fc") . md5($mybb->input['threadpass_password']));
				}
				threadpass_update_subs($tid);
				$db->update_query("threads", array(
					"threadpass_password" => $db->escape_string($threadpass_password) ,
					"threadpass_protected" => $protected
				) , "tid='{$tid}'");
			}
		}
		// At this point, they're not allowed. But since the password box wouldn't
		// have shown up to people without permission, they've obviously tried to inject it.
		// In which case, we'll just post their thread as usual without a password. That'll teach 'em.
	}
}
/* Trying to view reply page OR */
/* Trying to view a thread (in normal or archive mode) OR */
/* Trying to view the printed version of a thread OR */
/* Committing a reply to a thread */
function threadpass_thread() {
	global $thread, $mybb, $templates, $threadpass_return, $threadpass_form, $post, $lang;
	$lang->load("threadpass");
	// $backtrace = debug_backtrace();
	switch ($backtrace[1]['args'][0]) {
	case 'newreply_do_newreply_start':
		$threadpass_return = "hist-2";
		break;

	default:
		$threadpass_return = "showthread.php?tid=" . $thread['tid'];
		break;
	}
	$threadpass_return = base64_encode($threadpass_return);
	if (!threadpass_allowed($thread)) {
		threadpass_error($lang->passprotect, $threadpass_return);
		exit();
	}
}
/* Viewing list of threads in forum */
function threadpass_forumdisplay_thread() {
	global $mybb, $thread, $templates, $threadpass_affix, $affix_icon, $lang;
	$lang->load("threadpass");
	// Initialize the affix template with a null value to avoid it continuing from the last thread.
	$threadpass_affix = "";
	if ($thread['threadpass_protected'] <> 0) {
		if (!empty($mybb->settings["threadpass_thread_affix_icon"])) {
			$affix_icon = $mybb->settings["threadpass_thread_affix_icon"];
			eval("\$threadpass_affix = \"" . $templates->get('threadpass_thread_affix') . "\";");
		}
	}
}
/* Doing miscellanious things. Go figure. */
function threadpass_misc_start() {
	global $thread, $mybb, $templates, $threadpass_return, $lang;
	$lang->load("threadpass");
	switch ($mybb->input['action']) {
	case 'whoposted':
		global $threadpass_return;
		$threadpass_return = base64_encode("misc.php?action=whoposted&tid=" . $mybb->input['tid']);
		if (!threadpass_allowed(get_thread($mybb->input['tid']))) {
			threadpass_error($lang->passprotect, $threadpass_return);
		}
		break;

	case 'threadpass_authenticate':
		if ($mybb->user['uid'] && verify_post_check($mybb->input['my_post_key'], true) !== true) {
			error($lang->invalid_post_code);
		}
		$tid = intval($mybb->input['tid']);
		$thread = get_thread($tid);
		if ($thread) {
			// Attempt to authenticate the user
			if (threadpass_authenticate($thread)) {
				$mybb->input['r'] = base64_decode($mybb->input['r']);
				// Check if we have a special return value
				// Going back in history
				if (substr($mybb->input['r'], 0, 4) == "hist") {
					echo "<script type='text/javascript'>window.history.go(" . str_replace('hist', '', $mybb->input['r']) . ");</script>";
					die();
				}
				// Passed, send them where they want to go
				header("Location: " . $mybb->input['r']);
			}
			else {
				// Failed, show them the form again.
				$threadpass_return = $mybb->input['r'];
				threadpass_error($lang->authfailed);
			}
		}
		break;

	case 'threadpass_who_authed':
		global $header, $footer, $headerinclude, $authed_num, $whoauthed, $profile_link;
		$thread = get_thread(intval($mybb->input['tid']));
		if (!$thread) {
			return false;
		}
		if (!threadpass_allowed(get_thread($mybb->input['tid']))) {
			threadpass_error($lang->passprotect);
		}
		$authed_num = $authed_users = 0;
		if (!empty($thread['threadpass_authenticated_users'])) {
			$authed_users = explode("|", $thread['threadpass_authenticated_users']);
			$authed_num = count($authed_users);
		}
		$who_authed = "";
		if (!empty($authed_num) && !empty($thread['threadpass_authenticated_users'])) {
			foreach($authed_users as $uid) {
				$user = get_user($uid);
				$user_name = format_name($user['username'], $user['usergroup'], $user['displaygroup']);
				$profile_link = build_profile_link($user_name, $user['uid']);
				eval("\$whoauthed .= \"" . $templates->get("threadpass_who_authed_user") . "\";");
			}
		}
		else {
			$whoauthed = "<tr class='trow2' style='font-style: italic; font-family: courier new;'><td>None</td></tr>";
		}
		eval("\$threadpass_who_authed = \"" . $templates->get("threadpass_who_authed") . "\";");
		output_page($threadpass_who_authed);
		break;
	}
}
/* Parses syndication results */
function threadpass_parse_message_end(&$message) {
	// $backtrace = debug_backtrace();
	// Perform different tasks based on which file requested the parsed message
	switch (basename($backtrace[2]['file'])) {
	case 'syndication.php':
	case 'portal.php':
		global $mybb, $post, $announcement, $lang;
		$lang->load("threadpass");
		// This neat little hack passes along the list of assignments and sets $tid as whichever one isn't empty.
		// Because $post and $announcement will only be set in each of the certain files, it works rather splendidly.
		$tid = $post['tid'] = $announcement['tid'];
		if (!threadpass_allowed(get_thread($tid))) {
			// This is pretty lazy. Ideally I'd want the entire result to
			// be hidden from the search results but I haven't the patience to do it.
			$message = $lang->notpermission;
		}
		break;
	}
}
function threadpass_showthread_start() {
	global $mybb, $thread, $templates, $threadpass_authed_popup, $lang;
	$lang->load("threadpass");
	if ($thread['threadpass_protected'] != 0) {
		if ($mybb->user['uid'] == $thread['uid'] || threadpass_is_super($mybb->user['uid'])) {
			eval("\$threadpass_authed_popup = \"" . $templates->get("threadpass_authed_popup") . "\";");
		}
	}
}
/* End: /inc/plugins/Beardy/threadpass/plugin_hooks.php */